#------------------------------------------------------------------------------
#
#					MetaMake.mak
#
#			Generate metammi.min and all file paths.
#------------------------------------------------------------------------------
#   Date			  Name		Vers		Change
#	----------	 ------		----	-------------------------------
#	2006-05-19    ougq	   1.0   Init Version
# ------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
# 
#-------------------------------------------------------------------------------

USES_FOTA=no
USE_META=yes
META_TARGET=Arm
#-------------------------------------------------------------------------------
# Path to ARM 1.2 tools
#-------------------------------------------------------------------------------
ARMHOME = $(ARM12HOME)
ARMHOME := $(subst \,/,$(ARMHOME))

#-------------------------------------------------------------------------------
# Boot security type
#-------------------------------------------------------------------------------
ifeq ($(ASIC),M6280)
ifeq ($(USES_SECBOOT),yes)
   SEC_MODE = sec
else
   SEC_MODE = nonsec
endif
endif

ifeq ($(ASIC),M6260)
   ifeq ($(USES_ROMBOOT),yes)
      SEC_MODE = rom
   else
      SEC_MODE = nonsec
   endif
endif

export SEC_MODE

#-------------------------------------------------------------------------------
# Boot and component types
#-------------------------------------------------------------------------------
ifeq ($(USES_NAND_SDRAM),yes)
   FLASH_TYPE = nand
   BOOT_TYPE  = multiple
else
   ifeq ($(USES_NOR_PSRAM),yes)
      FLASH_TYPE = nor
      BOOT_TYPE  = single
   else
   ifeq ($(USES_NOR_SDRAM),yes)
         FLASH_TYPE = nor
         BOOT_TYPE  = single
      else
      FLASH_TYPE = shadow
      BOOT_TYPE  = single
   endif
endif
endif
#-------------------------------------------------------------------------------
# Target configuration type
#-------------------------------------------------------------------------------
ifeq ($(USES_SURF),yes)
   TARGCONFIG = surf
else
   ifeq ($(USES_FFA),yes)
      TARGCONFIG = ffa
   else
      TARGCONFIG = none
   endif
endif

ifeq ($(USES_SIGN_AMSS),yes)
   SIGN_AMSS = true
endif

#-------------------------------------------------------------------------------
# Secondary Boot Loader Generation
#-------------------------------------------------------------------------------
ifeq ($(USES_GEN_QC_SBL),yes)
   SBL_TYPE  = qcsbl
else
   ifeq ($(USES_GEN_OEM_SBL),yes)
      SBL_TYPE = oemsbl
   endif
endif

include incpaths.min

-include $(METAFILE)/MetaFilesCfg.min
#-------------------------------------------------------------------------------
# Generate all include and source files' path.
# עincpaths.min еMETAMMI 趨
#-------------------------------------------------------------------------------
GenMetaFilePath: $(METACFG)
	@echo ------------------------------------------------------------------------
	@echo $^ >$(METAFILE)/MetaFilesCfg.txt
	@echo Generating file MetaFilesAll.min: all meta file paths ...
	@perl genfilepath.pl $(METAFILE)/MetaFilesCfg.txt >$(METAFILE)/MetaFilesAll.min
	@echo ------------------------------------------------------------------------
	
		
-include $(METAFILE)/MetaFilesAll.min

#META_TRUOF_OBJECTS=$(subst .mif,mif.c,$(META_MIF_SRCS))
#META_TRUOF_OBJECTS= ATPowerOnOff.mif ATPowerffOnOff.mif
#-------------------------------------------------------------------------------
# Generate metammi.min
#-------------------------------------------------------------------------------
GenMetaMin:metainc metasrc
	@echo --------------------------------------------------------------------------
	@echo Generating file MetaFilesSrcMin.min : for META_AUTO_OBJS and mif CONSTFILE_FILES
	@perl genMetaSrcMin.pl $(METAFILE)/MetaFilesSrc.txt $(METAFILE)/MetaFilesCfg.txt >$(METAFILE)/MetaFilesSrcMin.min
	@echo --------------------------------------------------------------------------
	
metainc:
	@echo --------------------------------------------------------------------------
	@echo Generating file MetaFilesInc.txt: Inc files paths ...
	@echo $(wordlist	1, 500, $(META_INCS)) >$(METAFILE)/MetaFilesInc.txt	
	@echo $(wordlist	501, 1000, $(META_INCS)) >>$(METAFILE)/MetaFilesInc.txt
	@echo $(wordlist	1001, 1500, $(META_INCS)) >>$(METAFILE)/MetaFilesInc.txt
	@echo $(wordlist	1501, 10000, $(META_INCS)) >>$(METAFILE)/MetaFilesInc.txt

metasrc:	
	@echo --------------------------------------------------------------------------
	@echo Generating file MetaFilesSrc.txt: Src files paths ...
	@echo $(wordlist	1, 500, $(META_SRCS)) >$(METAFILE)/MetaFilesSrc.txt	
	@echo $(wordlist	501, 1000, $(META_SRCS)) >>$(METAFILE)/MetaFilesSrc.txt
	@echo $(wordlist	1001, 10000, $(META_SRCS)) >>$(METAFILE)/MetaFilesSrc.txt
	
#metainc:metauioneinc metasysteminc metaactorsinc metaextensioninc meta3partsinc 
#metauioneinc:$(META_UIONE_INCS)
#	@echo --------------------------------------------------------------------------
#	@echo Generating file MetaFilesInc.txt: Inc files paths ...
#	@echo $^ >MetaFilesInc.txt
#metaactorsinc:$(META_ACTORS_INCS)
#	@echo $^ >>MetaFilesInc.txt
#metaextensioninc:$(META_EXTENSION_INCS)
#	@echo $^ >>MetaFilesInc.txt
#meta3partsinc:$(META_3PARTS_INCS)
#	@echo $^ >>MetaFilesInc.txt
#metasysteminc:$(META_SYSTEM_INCS) $(META_INCS)
#	@echo $^ >>MetaFilesInc.txt
#	@echo --------------------------------------------------------------------------

#	@echo --------------------------------------------------------------------------
#	@echo Generating file MetaFilesIncMin.min : for META_AUTO_INC_PATH
#	@perl genMetaIncMin.pl MetaFilesInc.txt >MetaFilesIncMin.min
#	@echo --------------------------------------------------------------------------

#metasrc:metauionesrc metasystemsrc metaactorssrc metaextensionsrc meta3partssrc    
#metauionesrc:$(META_UIONE_SRCS)
#	@echo --------------------------------------------------------------------------
#	@echo Generating file MetaFilesSrc.txt: Src files paths ...
#	@echo $^ >MetaFilesSrc.txt
#metasystemsrc:$(META_SYSTEM_SRCS)
#	@echo $^ >>MetaFilesSrc.txt
#metaactorssrc:$(META_ACTORS_SRCS)
#	@echo $^ >>MetaFilesSrc.txt
#metaextensionsrc:$(META_EXTENSION_SRCS)
#	@echo $^ >>MetaFilesSrc.txt
#meta3partssrc:$(META_3PARTS_SRCS) $(META_SRCS)
#	@echo $^ >>MetaFilesSrc.txt
	
	
	
	@echo --------------------------------------------------------------------------
	
#	@echo --------------------------------------------------------------------------
#	@echo Generating file MetaFilesSrcMin.min : for META_AUTO_OBJS and mif CONSTFILE_FILES
#	@perl genMetaSrcMin.pl MetaFilesSrc.txt >MetaFilesSrcMin.min
#	@echo --------------------------------------------------------------------------

metalib:$(META_LIBS)
	@echo --------------------------------------------------------------------------
	@echo Generating file MetaLibs.min
	@echo META_LIBS = $^ >$(METAFILE)/MetaLibs.min
	@echo --------------------------------------------------------------------------
	
genQfilepath:
	@echo ------------------------------------------------------------------------
	@echo Generating Qualcomm file paths...
	@perl genQfilepath.pl -D$(METAFILE) $(ALL_PATHS)
	@echo ------------------------------------------------------------------------

CheckSrcFiles:
	@echo ------------------------------------------------------------------------
	@echo check src files...
	@perl CheckSrcFiles.pl $(OUTPUT) $(PROJECT)
	@echo ------------------------------------------------------------------------
	
-include $(METAFILE)/Qfiles.min 
GenAllSrcFileList:
	@echo ------------------------------------------------------------------------
	@echo Generating all file list...
	@if test ! -d $(OUTPUT)/dep; then mkdir $(OUTPUT)/dep; fi;
	@perl GenAllsrcFilesList.pl $(METAFILE)/MetaFilesSrc.txt $(METAFILE)/Qsrcfiles.txt $(METAFILE)/AllSrcFilsList.tbl
	@echo ------------------------------------------------------------------------	

clean:
	@echo ------------------------------------------------------------------------
	@echo clean...
	-if test -f $(METAFILE)/MetaFilesCfg.min; then rm -f $(METAFILE)/MetaFilesCfg.min; fi
	-if test -f $(METAFILE)/MetaFilesCfg.txt; then rm -f $(METAFILE)/MetaFilesCfg.txt; fi
	-if test -f $(METAFILE)/MetaFilesAll.min; then rm -f $(METAFILE)/MetaFilesAll.min; fi
	-if test -f $(METAFILE)/MetaFilesInc.txt; then rm -f $(METAFILE)/MetaFilesInc.txt; fi
	-if test -f $(METAFILE)/MetaFilesSrc.txt; then rm -f $(METAFILE)/MetaFilesSrc.txt; fi
	-if test -f $(METAFILE)/MetaFilesSrcMin.min; then rm -f $(METAFILE)/MetaFilesSrcMin.min; fi
	-if test -f $(METAFILE)/MetaLibs.min; then rm -f $(METAFILE)/MetaLibs.min; fi
	-if test -f $(METAFILE)/Qincfiles.txt; then rm -f $(METAFILE)/Qincfiles.txt; fi
	-if test -f $(METAFILE)/Qsrcfiles.txt; then rm -f $(METAFILE)/Qsrcfiles.txt; fi	
	-if test -f $(METAFILE)/Qfiles.min; then rm -f $(METAFILE)/Qfiles.min; fi
	-if test -d ../inc; then rm -r ../inc; fi
	-if test -f build$(META_PRJ).log; then rm -f build$(META_PRJ).log; fi
	-if test -f build$(META_PRJ).log.old; then rm -f build$(META_PRJ).log.old; fi	
	-if test -f build_time.bt; then rm -f build_time.bt; fi
	-if test -f ../../../Bin/$(META_PRJ)/SBNAX_$(META_PRJ).hex; then rm -f ../../../Bin/$(META_PRJ)/SBNAX_$(META_PRJ).hex; fi
	@echo ------------------------------------------------------------------------
