# ------------------------------------------------------------------------
#
#	genQfilepath.pl
#
# Notes:
#   - generate all qualcomm files' path
#
#   Date			  Name		Vers		Change
#	----------	 ------		----	-------------------------------
#	2006-04-01    tanrw	   1.0   Init Version
#	2006-05-08	tanrw	   1.1	   Add bt/*.c to include files list.
# ------------------------------------------------------------------------
use strict;
#use warnings;
use Cwd;
use File::Find;

my $curpath;
my $filepath;
my (@allpaths,$path);
my (%incfiles,%srcfiles);
my ($incfile,$srcfile);
# ---------- File handler ------------------
sub filehandler 
{
    # Check to make sure that it's a file, not a directory
    return unless -f $File::Find::name;
		
    # Just take the filename, and convert to lowercase
    my $nameonly = lc $_;
    
		my $namepath = $File::Find::name;
    
    # file types to search
    if(($nameonly =~ m/(\.h|\.bid|\.brh|\.inl|\.hpp)$/i) or ($namepath =~ m/\/bt\//i))
    {	
    	if((exists $incfiles{$nameonly}) and (lc($incfiles{$nameonly}) ne lc($namepath)))
    	{
    		print "#Replace $nameonly\n";
				print "#   --From: $incfiles{$nameonly}\n";
				print "#   --To:   $namepath\n";
    	}
    	$incfiles{$nameonly} = $namepath;
   	}
   	if($nameonly=~ m/(\.c|\.cpp|\.s)$/i)
   	{	
    	if((exists $srcfiles{$nameonly}) and (lc($srcfiles{$nameonly}) ne lc($namepath)))
    	{
    		print "#Replace $nameonly\n";
				print "#   --From: $srcfiles{$nameonly}\n";
				print "#   --To:   $namepath\n";
    	}
    	$srcfiles{$nameonly} = $namepath;
   	}
}


# ----------- Main ---------- 


@allpaths = @ARGV;

#get the current directory
$curpath = cwd;
$curpath =~s/\/build\/ms//g; 

$filepath = $ARGV[0];
$filepath =~s/-D//g;

foreach $path (@allpaths)
{
	if($path=~ m/-d/i) 
	{
		next;
	}
	$path =~s/\.\.\/\.\./$curpath/g;
	find( \&filehandler, "$path" );
}

open(INCFH, ">$filepath\/Qincfiles.txt");
open(FH,">$filepath\/Qfiles.min");

foreach (keys %incfiles)
{
	$incfiles{$_} =~ s/$curpath/\.\.\/\.\./g;
	print INCFH "$incfiles{$_} ";
	print FH "Q_INCS+=$incfiles{$_}\n";
}
close(INCFH);

open(SRCFH,">$filepath\/Qsrcfiles.txt");
foreach (keys %srcfiles)
{
	$srcfiles{$_} =~ s/$curpath/\.\.\/\.\./g;
	print SRCFH "$srcfiles{$_} ";
	print FH "Q_SRCS+=$srcfiles{$_}\n";
}

close(SRCFH);
close(FH);

print "\n";

exit;

